/**
 * @author 龙喜<xiaolong.lxl@alibaba-inc.com>
 * @description Base
 */

'use strict';

const utils = require('../lib/utils');
const config = require('../config');
const path = require('path');
const Debug = require('debug');
const debug = Debug('builder:base');

module.exports = class Base {
  static get INVOKE_TYPE_PREVIEW() {
    return 1;
  };

  static get INVOKE_TYPE_BUILD() {
    return 2;
  };

  /**
   * 构造方法
   * @param workSpace 工作空间
   * @param invokeType 调用类型 preview | build
   */
  constructor(workSpace, invokeType) {
    this.invokeType = invokeType || Base.INVOKE_TYPE_PREVIEW;
    this.workSpace = workSpace || config.defOptions.base || process.cwd();
    this.utils = utils;
  }
};
